#!/usr/bin/perl -w


# Convert RAW file to 16-bit, backward-endian table data for PIC18 devices.
# Input must be 640x480 x 8bpp; data 0x01 for white pixel, 0x00 for black one, as Paint Shop Pro does it.
# NOTE: data should have an even number of bytes! Otherwise, one garbage byte will be stored at the end of the table as padding...

($tablename, $junk)=split(/\./, $ARGV[0]); # Get the first part of the filename (without ".raw")


open INFILE, "< $ARGV[0]" or die "Couldn't open INFILE: $!\n"; 
open OUTFILE, "> $tablename.inc" or die "Couldn't open OUTFILE: $!\n";

#open HIGH, "> $tablename-high.txt" or die "Couldn't open high output: $!\n";
#open LOW, "> $tablename-low.txt" or die "Couldn't open low output: $!\n";

binmode(INFILE);


printf OUTFILE "; \$Id: \$\n\n; LCD data table (backward-endian) generated by raw2lcd.pl\n";

printf OUTFILE "; Input file name was $ARGV[0].\n\n";
printf OUTFILE "$tablename:\n";


read(INFILE, $buff, 640*480) == 640*480
        or die "input file too short...\n";


$num_bytes = length($buff);
printf "Length of buff is $num_bytes\n\n";


@outbuf=(0);		#initialize array as numeric(?)

@buff=split(//, $buff);

for ($line=0; $line<240; $line++)		# num. lines in a half screen
{
	for ($byte=0; $byte < 160; $byte++)	# num. 4-bit nibbles in a line
	{
		$bit3 = ord($buff[($line*640)+(4*$byte)+3]);
		#printf "$bit3";
		#$thisbyte=($line*640)+(4*$byte)+0;
		#printf "$thisbyte ";

		$bit2 = ord($buff[($line*640)+(4*$byte)+2]);
		#printf "$bit2";
		#$thisbyte=($line*640)+(4*$byte)+1;
		#printf "$thisbyte ";

		$bit1 = ord($buff[($line*640)+(4*$byte)+1]);
		#printf "$bit1";
		#$thisbyte=($line*640)+(4*$byte)+2;
		#printf "$thisbyte ";

		$bit0 = ord($buff[($line*640)+(4*$byte)+0]);
		#printf "$bit0";
		#$thisbyte=($line*640)+(4*$byte)+3;
		#printf "$thisbyte ";


		$bit7 = ord($buff[(($line+240)*640)+(4*$byte)+3]);
		#printf "$bit3";
		$bit6 = ord($buff[(($line+240)*640)+(4*$byte)+2]);
		#printf "$bit2";
		$bit5 = ord($buff[(($line+240)*640)+(4*$byte)+1]);
		#printf "$bit1";
		$bit4 = ord($buff[(($line+240)*640)+(4*$byte)+0]);
		#printf "$bit0";
		#printf "\n";
		$outbuf[($line*160)+$byte] = 128*$bit7 + 64*$bit6 + 32*$bit5 + 16*$bit4 + 8*$bit3 + 4*$bit2 + 2*$bit1 + $bit0;
	}
	printf "\n";

}

$num_bytes = @outbuf;
printf "Bytes in outbuf: $num_bytes\n";


for ($outbyte=0; $outbyte < (160*240 / 2); $outbyte++)
{
	printf OUTFILE ("\tDW H'%02X%02X'\n", $outbuf[$outbyte*2+1], $outbuf[$outbyte*2]); # PIC stores table data in backward order
}

close(INFILE);
close(OUTFILE);

